var volume_effect
var volume_music
var play_sound_eff
var play_sound_main
var current_song
var player_speed

(function($){
  $('body').append('<span id="playSound"></span>');

  $.extend({
    playSound: function(){
      if(play_sound_eff) $('#playSound').html("<embed src='"+arguments[0]+"' hidden='true' volume='"+volume_effect+"' class='s_eff' autostart='true' loop='false'>");

    }
  });

})(jQuery);
(function($){
  $('body').append('<span id="mainSound"></span>');

  $.extend({
    mainSound: function(){
      if(play_sound_main) $('#mainSound').html("<embed src='"+arguments[0]+"' hidden='true' volume='"+volume_music+"' autostart='true' class='s_main' loop='true'>");
    }
  });

})(jQuery);

Array.prototype.remove= function(){
    var what, a= arguments, L= a.length, ax;
    while(L && this.length){
        what= a[--L];
        while((ax= this.indexOf(what))!= -1){
            this.splice(ax, 1);
        }
    }
    return this;
}

$.fn.flash = function(times, duration) { var T = this; times = times || 2; duration = duration || 200; for ( var i=0; i < times; i++ ) { (function() { setTimeout(function() { T.fadeOut(duration, function() { T.fadeIn(duration); }); }, i*duration*2+50); })(i); } };

function compare_y(a,b) {
  if (a.y < b.y)
     return -1;
  if (a.y > b.y)
    return 1;
  return 0;
}


function startGame() {
			$('div#right article#quest_enjoy').fadeOut('slow')
			$('#info').html('Press [SPACE] to start').flash()
      jaws.switchGameState(GameGame)
    }
function restartGame() {
			$("#title").slideUp('normal')
      jaws.switchGameState(GameIntro)
    }
function GameIntro() {
		var blocks = new jaws.SpriteList()
		var height = 10
    var width  = 20
		var ticker = 0
		var player

		this.setup = function() {
			$.mainSound('res/sound/s0.ogg')
			current_song = 'res/sound/s0.ogg'

  		fps = document.getElementById("fps")
			var tiles = new jaws.SpriteSheet({ image: "res/tiles.png", frame_size: [32,32] })

			// Set air to top
		  for(var i = 0; i < 4; i++) {
		  	for(var i2 = 0; i2 < width; i2++) {
					if(i < 3){
		      	blocks.push( new Sprite({image: tiles.frames[8], x: i2*32, y: i*32}) )
					} else {
		       	blocks.push( new Sprite({image: tiles.frames[9], x: i2*32, y: i*32}) )
					}
		    }
		  }

			for(var ix = 0; ix < width; ix++) {
				for(var iy = 0; iy < height; iy++) {
					var rand = Math.floor(Math.random() * 7);
					if(Math.floor(Math.random()*20) == 1){ if(rand == 5){ rand++; rand++ } else { rand++ } }
		      blocks.push( new Sprite({image: tiles.frames[rand], x: ix*32, y: (iy+4)*32}) )
				}
			}

			for(var i = 0; i < 8; i++){
				var rand = Math.floor(Math.random()*5+1);
				var xx = Math.random()*(width*32);
				var yy = 150+Math.random()*(height*32-150);
				blocks.push( new Sprite({image: "res/trees/b"+rand+".png", x: xx, y: yy, anchor: "center_bottom" }) )
			}

			$('#info').html('Press [SPACE] to skip intro')

			/* CREATE PLAYER */
		  player = new jaws.Sprite({x:0, y:220, scale: 1, anchor: "center_bottom"})        
		
			player_speed = 2
		  var anim = new jaws.Animation({sprite_sheet: "res/sprite.png", frame_size: [100,70], frame_duration: 60})
		  player.anim_default = anim.slice(0,1)
		  player.anim_walking = anim.slice(1,24)
		  player.anim_down = anim.slice(25,35)
		  player.anim_up   = anim.slice(35,44)

			angel = new jaws.Sprite({x:0, y:228, anchor: "center_bottom"})
			anim = new jaws.Animation({sprite_sheet: "res/angel.png", frame_size: [40,50], frame_duration: 100 });
			angel.anim_default = anim.slice(0,1)
			angel.anim_walking = anim.slice(1,5)
			angel.anim_dead    = anim.slice(5,6)

			jaws.on_keydown(["esc","space"], startGame);
			jaws.preventDefaultKeys(["space"])
			player.flip()
			angel.flip()
			player.setImage( player.anim_walking.next() )
			angel.setImage( angel.anim_walking.next() )
		}
      
		this.update = function() {
			if(ticker < 400){
				player.move(0.6,0)
				angel.move(0.5,0)
				angel.setImage( angel.anim_walking.next() )
				player.setImage( player.anim_walking.next() )
			} else if(ticker == 441){
				player.setImage( player.anim_down.next() )
				$('#subgame img').attr('src','res/face/fluttershy.png')
				$('#subgame .text').html('What a wonderful day for a walk.<br />What do you think Angel?')
			} else if(ticker == 448){ 
				$('div#right').append( $('#quests').children('article#quest_enjoy') )
				$.playSound('res/sound/new_quest.wav');
			} else if(ticker == 620){
				$('#subgame img').attr('src','res/face/angel.png')
				$('#subgame .text').html('<strong><big>...</big></strong>')
			} else if(ticker > 650 && ticker < 1000){
				if(ticker == 780){
					$('#subgame img').attr('src','res/face/fluttershy.png')
					$('#subgame .text').html('<big>Angel? Where are you going?</big>')
				}
				angel.move(0.3,0.6)
				angel.setImage( angel.anim_walking.next() )
			} else if(ticker == 1001){
					$('#subgame img').attr('src','res/face/fluttershy.png')
					$('#subgame .text').html('<big>Better find him before something happens...</big>')
			} else if(ticker == 1050){
				$("#title").slideDown('slow');
				$.playSound('res/sound/bumm.wav');
				$('div#right article#quest_enjoy').css('background-color','#fdd')
			} else if(ticker == 1220){
				$('div#right article#quest_enjoy').fadeOut('slow')
				$('#info').html('Press [SPACE] to start').flash()
			}

			if(ticker % 100 == 0){ fps.innerHTML = jaws.game_loop.fps }
			ticker++;
		}



		this.draw = function() {
			jaws.clear()
			blocks.draw()
			player.draw()
			angel.draw()
		}
}

function GameEnd() {
		var blocks = new jaws.SpriteList()
		var height = 10
    var width  = 20
		var ticker = 0
		var player

		this.setup = function() {
			$.mainSound('res/sound/s0.ogg')
			current_song = 'res/sound/s0.ogg'

  		fps = document.getElementById("fps")
			var tiles = new jaws.SpriteSheet({ image: "res/tiles.png", frame_size: [32,32] })

			// Set air to top
		  for(var i = 0; i < 4; i++) {
		  	for(var i2 = 0; i2 < width; i2++) {
					if(i < 3){
		      	blocks.push( new Sprite({image: tiles.frames[8], x: i2*32, y: i*32}) )
					} else {
		       	blocks.push( new Sprite({image: tiles.frames[9], x: i2*32, y: i*32}) )
					}
		    }
		  }

			for(var ix = 0; ix < width; ix++) {
				for(var iy = 0; iy < height; iy++) {
					var rand = Math.floor(Math.random() * 7);
					if(Math.floor(Math.random()*20) == 1){ if(rand == 5){ rand++; rand++ } else { rand++ } }
		      blocks.push( new Sprite({image: tiles.frames[rand], x: ix*32, y: (iy+4)*32}) )
				}
			}

			for(var i = 0; i < 8; i++){
				var rand = Math.floor(Math.random()*5+1);
				var xx = Math.random()*(width*32);
				var yy = 150+Math.random()*(height*32-150);
				blocks.push( new Sprite({image: "res/trees/b"+rand+".png", x: xx, y: yy, anchor: "center_bottom" }) )
			}

			$('#info').html('Press [SPACE] to skip intro')

			/* CREATE PLAYER */
		  player = new jaws.Sprite({x:520, y:220, scale: 1, anchor: "center_bottom"})        
		
			player_speed = 2
		  var anim = new jaws.Animation({sprite_sheet: "res/sprite.png", frame_size: [100,70], frame_duration: 60})
		  player.anim_default = anim.slice(0,1)
		  player.anim_walking = anim.slice(1,24)
		  player.anim_down = anim.slice(25,35)
		  player.anim_up   = anim.slice(35,44)

			angel = new jaws.Sprite({x:520, y:228, anchor: "center_bottom"})
			anim = new jaws.Animation({sprite_sheet: "res/angel.png", frame_size: [40,50], frame_duration: 100 });
			angel.anim_default = anim.slice(0,1)
			angel.anim_walking = anim.slice(1,5)
			angel.anim_dead    = anim.slice(5,6)

			jaws.on_keydown(["esc","space"], restartGame);
			jaws.preventDefaultKeys(["space"])

			player.setImage( player.anim_walking.next() )
			angel.setImage( angel.anim_walking.next() )
		}
      
		this.update = function() {
			if(ticker < 400){
				player.move(-0.6,0)
				angel.move(-0.5,0)
				angel.setImage( angel.anim_walking.next() )
				player.setImage( player.anim_walking.next() )
			} else if(ticker == 401){
				player.setImage( player.anim_down.next() )
				$('#subgame img').attr('src','res/face/fluttershy.png')
				$('#subgame .text').html('Well this was a chaotic walk, wasnt it Angel?')
			} else if(ticker == 620){
				$('#subgame img').attr('src','res/face/angel.png')
				$('#subgame .text').html('<strong><big>...</big></strong>')
				$('#info').html('Press [SPACE] to restart').flash()
				$("#title").slideDown('slow');
			} else if(ticker > 630 && ticker < 1500){
				player.move(-0.6,0)
				angel.move(-0.6,0)
				angel.setImage( angel.anim_walking.next() )
				player.setImage( player.anim_walking.next() )
			}

			if(ticker % 100 == 0){ fps.innerHTML = jaws.game_loop.fps }
			ticker++;
		}



		this.draw = function() {
			jaws.clear()
			blocks.draw()
			player.draw()
			angel.draw()
		}
}

function GameGame() {
	var player
	var blocks
	var ticker = 45
	var rabbits = new Array()
	var fps
	var objs
	var noCollie
	var tiles
	var flowers = []
	var lastmove
	var inventory = []
	var lastmove_w
	var lastmove_h
	var ponies = new Array()
	var collies = new Array()
	var have_flower = false
	var width = 90
	var height = 90
	var sobj = new Array()
	var tile_map
	var inventory2 = []
	var viewport
	var direction = 0
	var angel
	var paused = false
	var zecora_state = 0
	var zecora_left = false
	var applejack_left = false
	var applejack_done = false
	var last = 0
	var movedx

	var quests = 0
	var max_quests = 5

	this.timeout = function(){
		var now = new Date().getTime();
		if(now > last+400){
			last = now
			return true
		} else {
			return false
		}
	}

	this.rabbit = function(image) {
		abbit = {}
		abbit.toxic = false
		abbit.moving = false
		abbit.left = false
		abbit.top = false
		abbit.die = false
		abbit.diecount = 700
		abbit.speed = 1
		abbit.found = false
		abbit.follow = false
		abbit.runaway = false
		abbit.moveable = true
		abbit.collision = false
		abbit.direction = 0
		if(image.indexOf("angel") != -1){
			//abbit.x = ((width*32)/2)+Math.random()*((width)*32/2)-100
			//abbit.y = ((height*32)/2)+Math.random()*((height-5)*32/2)-100
			abbit.x = 1700
			abbit.y = 844
			abbit.toxic = true
			console.log('placed angel!')
		} else {
			abbit.x = Math.random()*((width)*32)
			abbit.y = Math.random()*((height-5)*32)+210
		}
		abbit.sprite = new jaws.Sprite({x:abbit.x, y:abbit.y, scale: 0.9, anchor: "center_bottom"})
		abbit.animation = new jaws.Animation({sprite_sheet: image, frame_size: [40,50], frame_duration: 100 });
		abbit.sprite.anim_default = abbit.animation.slice(0,1)
		abbit.sprite.anim_walking = abbit.animation.slice(1,5)
		abbit.sprite.anim_dead    = abbit.animation.slice(5,6)
		if(image.indexOf("angel") != -1){
			abbit.sprite.setImage( abbit.sprite.anim_dead.next() )
		} else {
			abbit.sprite.setImage( abbit.sprite.anim_walking.next() )
		}
		return abbit
	}

	this.createApples = function(){
		for(var i = 0; i < 20; i++){
			var xx = Math.random()*(width*32);
			var yy = 250+Math.random()*(height*32-250);
			var apple = new Sprite({image: "res/misc/apple.png", x: xx, y: yy, anchor: "center_bottom" });
			apple.type = "apple"
			flowers.push( apple )
		}
	}

  this.setup = function() {
		if($('div#right article#quest_enjoy').length < 1){ $('div#right').append( $('#quests').children('article#quest_enjoy') ); $('div#right article#quest_enjoy').hide(); }
		
		$("#title").fadeIn('normal');
		$.mainSound('res/sound/s1.ogg')
		current_song = 'res/sound/s1.ogg'

  	fps = document.getElementById("fps")
		/*
		//	CREATE MAP
		*/
    blocks = new jaws.SpriteList()

		// create tiles
		tiles = new jaws.SpriteSheet({ image: "res/tiles.png", frame_size: [32,32] })

		// Set air to top
    for(var i = 0; i < 6; i++) {
    	for(var i2 = 0; i2 < width; i2++) {
				if(i < 5){
        	blocks.push( new Sprite({image: tiles.frames[8], x: i2*32, y: i*32}) )
				} else {
         	blocks.push( new Sprite({image: tiles.frames[9], x: i2*32, y: i*32}) )
				}
      }
    }

		$('#info').html('Press Arrow keys to Walk & [SPACE] for action').flash()

		var farmland = 
[
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,2,2,2,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,2,2,2,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,0,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,2,2,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,2,2,2,1,1,1,1,2,2,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,2,1,1,1,1,1,1,2,2,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,2,2,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,1,1,1,1,1,1,1,1,2,2,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,1,1,1,1,1,2,2,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,1,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,1,1,1,2,2,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,0,0,0,0,0,0,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,0,0,0,0,0,0,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,0,0,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,0,0,0,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],

]
		// Set random grass
    for(var i = 0; i < width; i++) {
      for(var i2 = 0; i2 < height-6; i2++) {
				if(farmland.length > i2 && farmland[0].length > i && farmland[i2][i] != 0){
					if(farmland[i2][i] == 1){
						var rand = Math.floor(Math.random() * 3)+10;
						if(Math.floor(Math.random()*20) == 1){ if(rand == 5){ rand++; rand++ } else { rand++ } }
				    blocks.push( new Sprite({image: tiles.frames[rand], x: i*32, y: (i2+6)*32}) )
					} else if(farmland[i2][i] == 2){
						var rand = Math.floor(Math.random() * 3)+14;
						if(Math.floor(Math.random()*20) == 1){ if(rand == 5){ rand++; rand++ } else { rand++ } }
				    blocks.push( new Sprite({image: tiles.frames[rand], x: i*32, y: (i2+6)*32}) )
						collies.push( new Sprite({image: tiles.frames[rand], x: i*32, y: (i2+6)*32}) )

					} else {
						var rand = Math.floor(Math.random() * 7);
						if(Math.floor(Math.random()*20) == 1){ if(rand == 5){ rand++; rand++ } else { rand++ } }
		      	blocks.push( new Sprite({image: tiles.frames[rand], x: i*32, y: (i2+6)*32}) )
					}
				} else {
					var rand = Math.floor(Math.random() * 7);
					if(Math.floor(Math.random()*20) == 1){ if(rand == 5){ rand++; rand++ } else { rand++ } }
		      blocks.push( new Sprite({image: tiles.frames[rand], x: i*32, y: (i2+6)*32}) )
				}
      }
    }
        

		// Place some trees
		for(var i = 0; i < (50+(Math.random()*2000)); i++){
			var rand = Math.floor(Math.random()*5+1)
			var xx = 300+Math.random()*(width*32-300)
			var yy = 550+Math.random()*(height*32-550)

			if(((xx < 1320 || xx > 1920) || (yy < 500 || yy > 1120)) &&
				 ((xx < 20   || xx > 240)  || (yy < 220 || yy > 620)) &&
				 ((xx < 2100 || xx > 2400) || (yy < 500 || yy > 800)) &&
				 ((xx < 1600 || xx > 1800) || (yy < 2050|| yy > 2400))
			){
			sobj.push( new Sprite({image: "res/trees/"+rand+".png", x: xx, y: yy, anchor: "center_bottom" }) )
			collies.push( new Sprite({ image:"res/collie.png", x:xx, y:yy, anchor: "center_bottom" }) )
			}
			//collies.push( new Rect(xx,yy,20,10) )
		}

		// Place some bushes & plants
		for(var i = 0; i < (300+(Math.random()*15000)); i++){
			var rand = Math.floor(Math.random()*5+1);
			var xx = Math.random()*(width*32);
			var yy = 250+Math.random()*(height*32-250);
			if(((xx < 1420 || xx > 1820) || (yy < 400 || yy > 1020)) &&
				 ((xx < 20   || xx > 240)  || (yy < 220 || yy > 620)) &&
				 ((xx < 2100 || xx > 2400) || (yy < 500 || yy > 800)) &&
				 ((xx < 1600 || xx > 1800) || (yy < 2050|| yy > 2400))
			){
			sobj.push( new Sprite({image: "res/trees/b"+rand+".png", x: xx, y: yy, anchor: "center_bottom" }) )
			if(xx > 250 || yy > 500){
			collies.push( new Sprite({ image:"res/collie.png", x:xx, y:yy, anchor: "center_bottom" }) )
			}
			}
			//collies.push( new Rect(xx,yy,20,10) )
		}

		// Place some heal flowers
		for(var i = 0; i < 4; i++){
			var xx = 1300+Math.random()*(width*32-1300)
			var yy = 1550+Math.random()*(height*32-1550)
			var sprite = new Sprite({image: "res/misc/flower.png", x: xx, y: yy, anchor: "center_bottom" });
			sprite.type = "heal_flower"
			flowers.push( sprite )
		}

		for(var i = 0; i < Math.random()*10; i++){
			var xx = Math.random()*(width*32);
			var yy = 250+Math.random()*(height*32-250);
			var apple = new Sprite({image: "res/misc/energie_apple.png", x: xx, y: yy, anchor: "center_bottom" });
			apple.type = "energie_apple"
			flowers.push( apple )
		}
		var apple = new Sprite({image: "res/misc/energie_apple.png", x: 140, y: 330, anchor: "center_bottom" });
		apple.type = "energie_apple"
		flowers.push( apple )

		var zecora_sprite = new Sprite({image: "res/zecora.png", x: 2274, y: 620, anchor: "center_bottom" });
		zecora_sprite.type = "zecora"
		ponies.push( zecora_sprite )

		var zecora_sprite = new Sprite({image: "res/applejack.png", x: 1700, y: 2200, anchor: "center_bottom" });
		zecora_sprite.type = "applejack"
		ponies.push( zecora_sprite )

		/* 
		//	INIT MAP STUFF 
		*/

    viewport = new jaws.Viewport({max_x: width*32, max_y: height*32})
    tile_map = new jaws.TileMap({size: [width, height], cell_size: [32,32]})
    tile_map.push(blocks)

		/* CREATE MOBS */
		for(ii = 0; ii < 10; ii++){
			rabbits.push( this.rabbit("res/rabbit.png")  )
			rabbits.push( this.rabbit("res/rabbit2.png") )
		}
		angel = this.rabbit("res/angel.png")


		/* CREATE PLAYER */
    player = new jaws.Sprite({x:2090, y:2090, scale: 0.9, anchor: "center_bottom"})        
  
    var anim = new jaws.Animation({sprite_sheet: "res/sprite.png", frame_size: [100,70], frame_duration: 40})
    player.anim_default = anim.slice(0,1)
    player.anim_walking = anim.slice(1,24)
    player.anim_down = anim.slice(25,35)
    player.anim_up   = anim.slice(35,44)

		player.up = false
		player.down = false
		player.left = false
		player.right = false

		player.collie = new Sprite({ image:"res/collie.png", x: player.x, y: player.y, anchor: "center_bottom" })
		player.setImage( player.anim_default.next() )
		jaws.preventDefaultKeys(["up", "down", "left", "right", "space" ,"p"])

window.setTimeout("if($('#rabbit_angel').html() != '1'){ $('#subgame img').attr('src','res/face/fluttershy.png'); $('#subgame .text').html('<big>i wonder where angel is ...</big>'); $.playSound('res/sound/new_quest.wav'); } $('div#right').append( $('#quests').children('article#quest_angel') ); $('div#right article#quest_quest_angel').flash();",2000)	

		window.setTimeout('$("#title").fadeOut("normal")',5000)


	}
		/*
		// UPDATE & CONTROL
		*/

	this.update = function() {

		if(ticker == 50){
			$('#questbox .have').html(""+quests)
	    fps.innerHTML = jaws.game_loop.fps +"<br />X: "+Math.floor(player.x)+" Y:"+Math.floor(player.y)


			if($("#questbox .have").html() == $("#questbox .max").html()){
				$('#done').slideDown('slow').delay(5000).slideUp('slow');
				jaws.switchGameState(GameEnd)
			}

			/* May spawn more zombie rabbits */
			var rand = Math.random()*180/(parseInt($('#rabbit_collected').html())/10.0)
			if(rand < 1){
				rabbits.push( this.rabbit("res/rabbit.png")  )
			} else if(rand < 2){
				rabbits.push( this.rabbit("res/rabbit2.png")  )
			}
			//$('#rabbit_max').html(rabbits.length)
			ticker = 0
		}

		if(jaws.pressed("p")){
			jaws.game_loop.pause();
			$('#pause').fadeIn('normal')
		}

		/* 
		//	COLLISION & ORDER
		*/ 
		/* Proxy all objects for Y order ... */
		objs = []
		objs[0] = player
		objs[1] = angel.sprite

		for(var i = 0; i < sobj.length; i++){
			objs.push(sobj[i])
		}
		for(var i = 0; i < flowers.length; i++){
			objs.push(flowers[i])
		}
		for(var i = 0; i < ponies.length; i++){
			objs.push(ponies[i])
		}
		

		/* 
		// MEGA RABBIT UPDATE
		*/
		for(i = 0; i < rabbits.length; i++){ 
			if(rabbits[i].sprite != undefined){
				/* Check if he may bites angel */
				if(angel.follow == false &&
					rabbits[i].sprite.x < angel.sprite.x+20 && rabbits[i].sprite.x > angel.sprite.x-20 &&
					rabbits[i].sprite.y < angel.sprite.y+20  && rabbits[i].sprite.y > angel.sprite.y-20){
					if(Math.floor(Math.random()*10) == 4){
						angel.toxic = true
						angel.sprite.setImage( angel.sprite.anim_dead.next() )
						//$("#rabbit_angelmax").html("0")
						//$('#quest_angel').addClass('failed')
					}
				}

				if(rabbits[i].die){
					if(rabbits[i].diecount < 1){ 
						rabbits.slice(i,1) 
					} else { 
						rabbits[i].diecount = rabbits[i].diecount-1; 
						rabbits[i].sprite.scale(rabbits[i].diecount/700) 
					}
				} else if(rabbits[i].sprite.x < player.x+30 && rabbits[i].sprite.x > player.x-30 &&
					rabbits[i].sprite.y < player.y+10 && rabbits[i].sprite.y > player.y-10){
					if(jaws.pressed("space"))  {
						rabbits[i].die = true
						$.playSound('res/sound/bumm.wav');
						rabbits[i].sprite.setImage( rabbits[i].sprite.anim_walking.next() )
						$('#rabbit_collected').html(parseInt($('#rabbit_collected').html())+1)
						if($('#rabbit_collected').html() == $('#rabbit_max').html() && $('#rabbit_collected').html() != '0' && $('#rabbit_collected').html() != ''){
							$("div#right article#quest_rabbits").css('background-color','#dfd').delay(2000).fadeOut('slow')
							quests++;
							$.playSound('res/sound/ok.wav');
						}
					}
					
				} else if(rabbits[i].sprite.x < player.x+80 && rabbits[i].sprite.x > player.x-80 &&
					rabbits[i].sprite.y < player.y+60 && rabbits[i].sprite.y > player.y-60){
					if(rabbits[i].sprite.x > player.x){ rabbits[i].left = false } else { rabbits[i].left = true }
					if(rabbits[i].sprite.y > player.y){ rabbits[i].top = false  } else { rabbits[i].top = true  }
					if($('div#right #quest_rabbits').length == 0){
						$('div#right').append( $('#quests').children('article#quest_rabbits') )
						$('div#right article#quest_rabbits').flash(); 
						$('#subgame img').attr('src','res/face/fluttershy.png')
						$('#subgame .text').html('Where do all that Zombie Bunnies came from? I may better destroy them before they hurt anyone.')
						$.playSound('res/sound/new_quest.wav');			
					}
					rabbits[i].runaway = true
					rabbits[i].speed = Math.random()*4.2
				} else {
					rabbits[i].speed = 1
				}

				if(rabbits[i] != undefined) objs.push(rabbits[i].sprite)
			} else { console.log('fail @rabbits') }

			if(Math.floor(Math.random()*400) == 1 || rabbits[i].runaway == true){
				rabbits[i].moving = true
				if(!rabbits[i].runaway){
					var dat = Math.random()*10
					if(dat < 4){ rabbits[i].left = true } else if(dat > 6) { rabbits[i].left = false }
					dat = Math.random()*10
					if(dat < 4){ rabbits[i].top  = true } else if(dat > 6) { rabbits[i].top  = false }
				} else { 	rabbits[i].runaway = false }
			} else if(Math.random()*200 < 4){ rabbits[i].moving = false; if(Math.random()*20 < 1){ rabbits[i].speed = 1.6 } }

			if(rabbits[i].moving == true){
				rabbits[i].sprite.setImage( rabbits[i].sprite.anim_walking.next() )
				if(rabbits[i].left){ 
					if(rabbits[i].sprite.x > 10){ 
						rabbits[i].sprite.move(-rabbits[i].speed,0);
						if(rabbits[i].direction == 1){ rabbits[i].direction = 0; rabbits[i].sprite.flip() } 
					} else { rabbits[i].left = false }
				} else { 
					if(rabbits[i].sprite.x < width*32-12){ 
						rabbits[i].sprite.move(rabbits[i].speed,0); 
						if(rabbits[i].direction == 0){ rabbits[i].direction = 1; rabbits[i].sprite.flip() } 
					} else { rabbits[i].left = true }
				}
				if(rabbits[i].top) { 
					if(rabbits[i].sprite.y > 200){ 
						rabbits[i].sprite.move(0,-rabbits[i].speed);
					} else { rabbits[i].top = false }
				} else { 
					if(rabbits[i].sprite.y < height*32-4){
						rabbits[i].sprite.move(0,rabbits[i].speed); 
					} else { rabbits[i].top = true }
				}
			}
		}

		/* 
		// ANGEL UPDATE (ugly coding, i know...) 
		*/
		if(angel.follow == false && angel.toxic == false && 
					angel.sprite.x < player.x+50 && angel.sprite.x > player.x-50 &&
					angel.sprite.y < player.y+20 && angel.sprite.y > player.y-20){
					angel.sprite.setImage( angel.sprite.anim_walking.next() )
					angel.moving = false
		}
		if(angel.follow == false && 
					angel.sprite.x < player.x+40 && angel.sprite.x > player.x-40 &&
					angel.sprite.y < player.y+30 && angel.sprite.y > player.y-30){
					if(jaws.pressed("space"))  {
						if(angel.toxic == false){
							angel.follow = true
							$('#quest_angel').addClass('done')
							$("div#right article#quest_angel").css('background-color','#dfd').delay(2000).fadeOut('slow');
							quests++;
							$('#subgame img').attr('src','res/face/fluttershy.png')
							$('#subgame .text').html('I am so happy i have found you and nothing bad happened yet. It seems very dangerous here at the moment. Now stick at me Angel.')

							window.setTimeout("$('#subgame img').attr('src','res/face/angel.png'); $('#subgame .text').html('<strong><big>...</big></strong>')",8000)
							window.setTimeout("$('#subgame img').attr('src','res/face/none.png'); $('#subgame .text').html('')",14000)
							$('#rabbit_angel').html("1")
							$.playSound('res/sound/ok.wav');
						} else {

							if(have_flower && angel.found){
								$("div#right article#quest_find_health").css('background-color','#dfd').delay(2000).fadeOut('slow')
								quests++;
								angel.toxic = false;	
								angel.setImage( angel.anim_walking.next() )
								angel.follow = true;
							$.playSound('res/sound/ok.wav');
								$('#subgame img').attr('src','res/face/fluttershy.png')
								$('#subgame .text').html('I am so glad you are ok! Now follow me and take care!')
								window.setTimeout("$('#subgame img').attr('src','res/face/angel.png');$('#subgame .text').html('<strong><big>...</big></strong>')")
							} else {

								if($('div#right #quest_find_health').length == 0){
									$("div#right article#quest_angel").css('background-color','#dfd').delay(2000).fadeOut('slow')
									quests++;
									$.playSound('res/sound/ok.wav');
									angel.found = true
									$('#subgame img').attr('src','res/face/fluttershy.png')
									$('#subgame .text').html('Oh no ... Angel was bitten. Better find somepony who has an idea how to help him!')
		
									$('div#right').append($('article#quest_find_health'))
								$('div#right article#quest_find_health').flash(); 
									$.playSound('res/sound/new_quest.wav');
								} else {
									$('#subgame img').attr('src','res/face/fluttershy.png')
									$('#subgame .text').html('<big>Better find somepony who can help him...</big>')
								}
							}
						}
					}
		}

		/* 
		// ANGEL: RANDOM MODE
		*/
		if(angel.follow == false){
			if(angel.toxic == false && Math.floor(Math.random()*400) == 1 || angel.runaway == true){
				angel.moving = true
				if(!angel.runaway){
					var dat = Math.random()*10
					if(dat < 4){ angel.left = true } else if(dat > 6) { angel.left = false }
					dat = Math.random()*10
					if(dat < 4){ angel.top  = true } else if(dat > 6) { angel.top  = false }
				} else { 	angel.runaway = false }
			} else if(Math.floor(Math.random()*100) == 1){ angel.moving = false; }

			if(angel.moving == true){
				if(angel.toxic){ angel.moving == false } else {
					angel.sprite.setImage( angel.sprite.anim_walking.next() )
					if(angel.left){ 
						if(angel.sprite.x > 10){ 
							angel.sprite.move(-angel.speed,0);
							if(angel.direction == 1){ angel.direction = 0; angel.sprite.flip() } 
						} else { angel.left = false }
					} else { 
						if(angel.sprite.x < width*32-12){ 
							angel.sprite.move(angel.speed,0); 
							if(angel.direction == 0){ angel.direction = 1; angel.sprite.flip() } 
						} else { angel.left = true }
					}
					if(angel.top) { 
						if(angel.sprite.y > 200){ 
							angel.sprite.move(0,-angel.speed);
						} else { angel.top = false }
					} else { 
						if(angel.sprite.y < height*32-4){ 
							angel.sprite.move(0,angel.speed); 
						} else { angel.top = true }
					}
				}
			}

		/* 
		// ANGEL: FOLLOW MODE
		*/
		} else {
			angel.speed = 1.6
			var moved = false
			if(angel.sprite.x < player.x-36)			{ 
				if(angel.direction == 0){ angel.direction = 1; angel.sprite.flip() } 
				angel.sprite.move( angel.speed,0);
				angel.sprite.setImage(angel.sprite.anim_walking.next())
				moved = true
			}
			else if(angel.sprite.x > player.x+36)	{
				if(angel.direction == 1){ angel.direction = 0; angel.sprite.flip() } 
				angel.sprite.move(-angel.speed,0);
				angel.sprite.setImage(angel.sprite.anim_walking.next())
				moved = true
			}
			if(angel.sprite.y < player.y-36)			{ 
				angel.sprite.move(0,angel.speed );
				angel.sprite.setImage(angel.sprite.anim_walking.next())
				moved = true
			}
			else if(angel.sprite.y > player.y+36)	{ 
				angel.sprite.move(0,-angel.speed);
				angel.sprite.setImage(angel.sprite.anim_walking.next()) 
				moved = true
			}
			if(!moved){ player.setImage(player.anim_default.next()) }
		}
		/* 
		// ANGEL END
		*/
		function collides(){ if(jaws.collideOneWithMany(player.collie,collies).length>0){ 

			if(lastmove_h == "up")   { player.move(0, player_speed) }
			if(lastmove_h == "down") { player.move(0,-player_speed) }
			if(lastmove_w == "left") { player.move( player_speed,0) }
			if(lastmove_w == "right"){ player.move(-player_speed,0) }
			
			collided = true;
			
			return true;
		} else { noCollie = [player.x,player.y]; return false; collided = false; } }

		function setZacora(num){
			zecora_state = num;
		}

		/*
		//	DETECT OTHER PONIES
		*/
		var pc = jaws.collideOneWithMany(player,ponies)
		if(pc.length>0 && this.timeout()){
			var elemx
			pc.forEach(function(elem,index){
				for(var i = 0; i < ponies.length; i++){
					if(ponies[i].x == elem.x && ponies[i].y == elem.y){ 
						elemx = elem; break; 
					}
				}
			});
			if(jaws.pressed("space")){
				if(elemx.type == "zecora"){
					$('#subgame img').attr('src','res/face/zecora.png')
					$('#subgame .text').html('Hi Fluttershy, how is it going?')
					if($('div#right #quest_find_flower').length != 0) {
						if(angel.follow){
							$('#subgame img').attr('src','res/face/zecora.png');
							$('#subgame .text').html('I am glad i could help you with your little Friend')
						} else {
							$('#subgame img').attr('src','res/face/zecora.png');
							$('#subgame .text').html('Hurry up, find those Flowers. May it will be to late else.')
						}
					} else if(angel.found && zecora_state == 0){
						window.setTimeout("$('#subgame img').attr('src','res/face/fluttershy.png');			$('#subgame .text').html('What i chaotic day... First Angel ran away now he was bitten by an Zombie Bunnie... i have no idea what to do with him now')",3000)
						window.setTimeout("$('#subgame img').attr('src','res/face/zecora.png');			$('#subgame .text').html('Calm down Fluttershy, bring him one of the Purple flowers you can find around!');$('div#right').append( $('#quests').children('article#quest_find_flower') ); $('div#right article#quest_find_flower').flash(); $.playSound('res/sound/new_quest.wav');",6000)
						window.setTimeout("$('#subgame img').attr('src','res/face/none.png');')",10000)
					} else if(zecora_state == 0) {
						window.setTimeout("$('#subgame img').attr('src','res/face/fluttershy.png');			$('#subgame .text').html('<big>I lost Angel, have you may seen him?</big>')",3000)
						window.setTimeout("$('#subgame img').attr('src','res/face/zecora.png');			$('#subgame .text').html('<big>Im sorry, no</big>')",6000)
						window.setTimeout("$('#subgame img').attr('src','res/face/none.png'); $('#subgame .text').html('');",10000)
					} else {
						$('#subgame img').attr('src','res/face/zecora.png');
						$('#subgame .text').html('Hi Fluttershy')
					}
				} else if(elemx.type == "applejack"){
					if($('div#right #quest_find_apples').length == 0){
						$('#subgame img').attr('src','res/face/applejack.png')
						$('#subgame .text').html('Haidi ho, fellow. Good you come over!<br />I really need your help!')
						window.setTimeout("$('#subgame img').attr('src','res/face/applejack.png'); $('#subgame .text').html('I feel a little static at the moment. May you can bring me 10 Apples?');",4000)
						for(var i = 0; i < 20; i++){
							var xx = Math.random()*(width*32);
							var yy = 250+Math.random()*(height*32-250);
							var apple = new Sprite({image: "res/misc/apple.png", x: xx, y: yy, anchor: "center_bottom" });
							apple.type = "apple"
							flowers.push( apple )
						}
						$('div#right').append( $('#quests').children('article#quest_find_apples') );
						$('div#right article#quest_find_apples').flash(); 
						$.playSound('res/sound/new_quest.wav');
					} else {
						if(applejack_done){
							$('#subgame img').attr('src','res/face/applejack.png')
							$('#subgame .text').html('Hi again Fluttershy, thanks again for the Apples!')
						} else {
							if(parseInt($("#apples_collected").html()) > 9){
								$('#subgame img').attr('src','res/face/applejack.png')
								$('#subgame .text').html('Awesome thx! Take some of these Energie Apples as reward!')
								$("div#right article#quest_find_apples").css('background-color','#dfd').delay(2000).fadeOut('slow');
								quests++;
								$.playSound('res/sound/ok.wav');
								for(var i = 0; i < 3; i++){
									var apple = new Sprite({image: "res/misc/energie_apple.png", x: 1670+(i*26), y: 2350, anchor: "center_bottom" });
									apple.type = "energie_apple"
									flowers.push( apple )
								}
								applejack_done = true
							} else {
								$('#subgame img').attr('src','res/face/applejack.png')
								$('#subgame .text').html('Im sorry Fluttershy, but i need atleast 10!')
							}
						}
					}
				}
			}
		}

		/* 
		// DETECT TAKEABLE
		*/

		if(jaws.pressed("space") && this.timeout()){
			var fc = jaws.collideOneWithMany(player.collie,flowers)
			if(fc.length>0){
				var elemx
				fc.forEach(function(elem,index){
					for(var i = 0; i < flowers.length; i++){
						if(flowers[i].type == "energie_apple"){
							if(flowers[i].x == elem.x && flowers[i].y == elem.y){ elemx = elem; inventory.push(flowers.splice(i,1)); inventory2.push('Energie Apple'); have_energie_apple = true; $.playSound('res/sound/pickup.wav'); $('#subgame img').attr('src','res/face/fluttershy.png'); $('#subgame .text').html('Yay! This makes me 20% faster!'); player_speed += 0.4; break; }

						} else if(flowers[i].type == "apple"){
							if(flowers[i].x == elem.x && flowers[i].y == elem.y){ elemx = elem; inventory.push(flowers.splice(i,1)); inventory2.push('Apple'); have_energie_apple = true; $.playSound('res/sound/pickup.wav'); $("#apples_collected").html(parseInt($("#apples_collected").html())+1);
if(parseInt($("#apples_collected").html()) == 9){ $('#subgame .text').html('Only one more Apple to go'); $('#subgame img').attr('src','res/face/applejack.png'); } break; }

						} else if(flowers[i].type == "heal_flower" && $('div#right #quest_find_flower').length != 0){
							if(flowers[i].x == elem.x && flowers[i].y == elem.y){ elemx = elem; inventory.push(flowers.splice(i,1)); inventory2.push('Heal Flower'); have_flower = true; $.playSound('res/sound/pickup.wav'); break; }

						} else if(elem.type == "heal_flower"){
							$('#subgame img').attr('src','res/face/fluttershy.png')
							$('#subgame .text').html('I dont want to touch them, they may are poisoned')
						}
					}
				});
				if(elemx.type == "heal_flower"){
					$("div#right article#quest_find_flower").css('background-color','#dfd').delay(2000).fadeOut('slow')
					quests++;
					$('#subgame img').attr('src','res/face/fluttershy.png')
					$('#subgame .text').html('May this is the Flower that can help Angel?')
				}
			}
		}

		/* 
		// PLAYER UPDATE
		*/
		var collided = false
		var moved = false
		

    if(jaws.pressed("up"))    {
			movedx = false
			lastmove_h = "up"
			moved = true
			player.up = true
			if(player.y > 204){ player.move(0, -player_speed); player.setImage(player.anim_up.next()) }
		} else { if(!collided){ player.up = false } }
    if(jaws.pressed("down"))  {
			lastmove_h = "down"
			movedx = false
			moved = true
			player.down = true
			if(player.y < height*32-4){ player.move(0, player_speed);  player.setImage(player.anim_down.next()) }
		} else { if(!collided){ player.down = false } }

		if(jaws.pressed("left"))  {
			lastmove_w = "left"
			player.left = true
			moved = true
			movedx = true
			if(player.x > 0+32){ 
				if(direction == 1){ player.flip(); direction = 0; }
				player.move(-player_speed,0);
				player.setImage(player.anim_walking.next())
			} 
		} else { if(!collided){ player.left = false } }
    if(jaws.pressed("right")) {
			lastmove_w = "right"
			player.right = true
			moved = true
			movedx = true
			if(player.x < width*32-32){
				if(direction == 0){ player.flip(); direction = 1; }
				player.move(player_speed,0);
				player.setImage(player.anim_walking.next()) 
			}
		} else { if(!collided){ player.right = false } }
		collides()
		player.collie.moveTo(player.x,player.y)

		if(!moved){
			if(lastmove_h == "up" && !movedx){
				while(!player.anim_up.atFirstFrame()){
					player.setImage( player.anim_up.next() )
				}
			} else if(lastmove_h == "down" && !movedx){
				while(!player.anim_down.atFirstFrame()){
					player.setImage( player.anim_down.next() )
				}
			}
			if(movedx){
				player.setImage( player.anim_default.next() )
			}
		}

		/* 
		// PLAYER END
		*/

    if(!collided){ viewport.centerAround(player) }

		ticker++
	}

	this.draw = function() {
		jaws.clear()

		viewport.drawTileMap( tile_map )

		objs.sort(compare_y)
		for(i = 0; i < objs.length; i++){
			viewport.draw( objs[i] )
		}

	}
}
    
jaws.onload = function() {
	jaws.unpack()
	jaws.assets.add(["res/sprite.png","res/tiles.png","res/collie.png","res/rabbit.png","res/rabbit2.png","res/angel.png"])
	jaws.start(GameIntro)
}

$(document).ready(function(){
	$("#cloud1")
		.css('left',(-100 + ( Math.random() * ($(window).width()  + 200))) +"px")
		.css('top', (-100 + ( Math.random() * ($(window).height() ))) +"px")
	$("#cloud2")
		.css('left',(-100 + ( Math.random() * ($(window).width()  + 200))) +"px")
		.css('top', (-100 + ( Math.random() * ($(window).height() ))) +"px")
	$("#cloud3")
		.css('left',(-100 + ( Math.random() * ($(window).width()  + 200))) +"px")
		.css('top', (-100 + ( Math.random() * ($(window).height() ))) +"px")
	$("#cloud4")
		.css('left',(-100 + ( Math.random() * ($(window).width()  + 200))) +"px")
		.css('top', (-100 + ( Math.random() * ($(window).height() ))) +"px")
	$("#cloud5")
		.css('left',(-100 + ( Math.random() * ($(window).width()  + 200))) +"px")
		.css('top', (-100 + ( Math.random() * ($(window).height() ))) +"px")
	$('div#right article.done').live('click', function(){ $(this).hide() });

	if(window.location.href.indexOf('m33w.tk') == -1){
		$('#local').fadeIn('slow');
	}
	$('#local').click(function(){ $(this).fadeIn('slow'); });

	volume_effect = 80
	volume_music  = 80
	play_sound_eff = true
	play_sound_main = true
	current_song = 'res/sound/s0.ogg'

	// Toggle sound
	$('#t_main_sound').live('click',function(){
		if(play_sound_main){
			play_sound_main = false
			$('.s_main').remove()
			$(this).attr('src','res/misc/sound_off.png')
			$.cookie('sound_main', 'false', { expires: 3 });
		} else {
			play_sound_main = true
			$.mainSound(current_song)
			$(this).attr('src','res/misc/sound_on.png')
			$.cookie('sound_main', 'true', { expires: 3 });
		}
	});
	$('#t_effect_sound').live('click',function(){
		if(play_sound_eff){
			play_sound_eff = false
			$('.s_eff').remove()
			$.cookie('sound_eff', 'false', { expires: 3 });
			$(this).attr('src','res/misc/sound_off.png')
		} else {
			play_sound_eff = true
			$.cookie('sound_eff', 'true', { expires: 3 });
			$(this).attr('src','res/misc/sound_on.png')
		}
	});

	if($.cookie('sound_eff') == "false"){
			play_sound_eff = false
			$('.s_eff').remove()
			$.cookie('sound_eff', 'false', { expires: 3 });
			$('#t_effect_sound').attr('src','res/misc/sound_off.png')
	}

	if($.cookie('sound_main') == "false"){
			play_sound_main = false
			$('.s_main').remove()
			$.cookie('sound_main', 'false', { expires: 3 });
			$('#t_main_sound').attr('src','res/misc/sound_off.png')
	}

	$('#pause').click(function(){
		$(this).fadeOut('normal')
		window.setTimeout('jaws.game_loop.unpause();',300)
	});
});

